# 浮动（float）

 ## 为什么需要浮动

- 最初浮动是为了像word有文字环绕，图片嵌入的功能出现的

  ![image-20210120091803284](E:\web\lessons\课件\csspress\float.assets\image-20210120091803284.png)

- 让多个块级元素水平排列成一行

  ![image-20210120092034942](E:\web\lessons\课件\csspress\float.assets\image-20210120092034942.png)

- 实现两个块级盒子的左对齐和右对齐

![image-20210120092428804](E:\web\lessons\课件\csspress\float.assets\image-20210120092428804.png)

## 浮动的本质

1. 浮动的包裹性

   抛开浮动的破坏性先不谈，浮动就是个带有方位的display:inline-block的属性。
   display:inline-block 某种意义上的作用就是包裹，浮动也有类似的效果

   但是 float和display:inline-block 无法完全等同  

   原因：

   - float可以自定义方向（从左往右或从右往左）   inline-block只有从左到右一个水平排列的方向
   - float会使周围文字环绕元素   inline-block不会

2. 浮动的破坏性

   浮动会破坏正常的inline boxes

   什么是inline boxes?

   ![image-20210120102415347](E:\web\lessons\课件\csspress\float.assets\image-20210120102415347.png)

inline boxes不会让内容成块显示，而是排成一行，如果外部含inline属性的标签(span,a,cite等)，则属于inline boxes，如果是个光秃秃的文字，则属于匿名inline boxes。

Linebox 

![image-20210120102812428](E:\web\lessons\课件\csspress\float.assets\image-20210120102812428.png)



正常的图文混排：

不加float:

![image-20210120103521672](E:\web\lessons\课件\csspress\float.assets\image-20210120103521672.png)

（加入float之后）：

![image-20210120103339657](E:\web\lessons\课件\csspress\float.assets\image-20210120103339657.png)

正常情况下，图片自身就是个inline boxes，与两侧的文字inline boxes共同组成了line boxes，但是，一旦图片加入了浮动，情况就完全变了。我认为是浮动彻底破坏了img图片的inline boxes特性，至少有一点我可以肯定，图片的inline boxes不存在了。被恶魔附体，变身了，而这个恶魔就是浮动。一旦图片失去了inline boxes特性就无法与inline boxes的文字排在一行了，其会从line boxes上脱离出来，跟随自身的方位属性，靠边排列

## float 使用 

```
float:left  左浮动

float:right  右浮动
```

float:left 实现块级元素水平排列：

![image-20210120103840173](E:\web\lessons\课件\csspress\float.assets\image-20210120103840173.png)

```
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <style>
        *{
            margin:0;
            padding: 0;
        }
        .box{
            width: 1000px;
            height: 300px;
            background: gold;
            margin: 20px;
        }
        .box1{
            /* width:60px;
            height: 60px; */
            background: red;
            /* background: rgba(255, 0, 0, 0.363); */
            /* float: left; */
            

        }
        .box2{
            width: 120px;
            height:80px;
            background: gray;
            border: 1px solid pink;
            /* float:right */
            float: left;
        }
        .a{
            /* width: 70px;
            height: 70px;
            border: 1px solid blue;
            background: pink; */
            clear: right;
        }
    </style>
</head>
<body>
    <div class="box">
        <div class="box1">asaaaa</div>
        <div class="box2"></div>
        <div class="box2"></div>
        <div class="box2"></div>
        <div class="box2"></div>
        <div class="box2"></div>
        <div class="box2"></div>
        
     
    </div>
</body>
</html>
```





## 清除浮动

```
clear:left(清除左浮动)/right(清除右浮动)/both(清除左浮动+右浮动)
```

哪边不允许有浮动元素，clear就是对应方向的值，两边都不允许就是`both`

方案1：给需要清浮动的元素加clear属性

```
  .box4{
            width: 120px;
            height:80px;
            background: blue;
            border: 1px solid pink;
            clear: left;
        }
```

方案2：

html:

```
<div class="box">
        <div class="box1">asaaaa</div>
        <div class="box2"></div>
        
        <div class="box2">4</div>
        <div class="box2">5</div>
        <!-- <div class="box2" style="height: 180px;">6</div> -->
        <div class="blank"></div>
        <div class="box4"></div>
    </div>
```

css:

```
 .blank{
            clear: left;
        }
```



方案3：使用伪元素清除浮动

css:

```
.boxes:after {
            content: '.';
            height: 0;
            display: block;
            clear: both;
        }
```

html:

```
<div class="box">
        <div class="boxes clearfix">
            <div class="box1">asaaaa</div>
            <div class="box2"></div>

            <div class="box2">4</div>
            <div class="box2 blankdiv">5</div>
            <!-- <div class="box2" style="height: 180px;">6</div> -->
            <div class="blank"></div>
        </div>
        <div class="box4"></div>

    </div>
```



方案4：overflow 清除浮动

html：

```
<div class="box">
        <div class="boxes clearfix">
            <div class="box1">asaaaa</div>
            <div class="box2"></div>

            <div class="box2">4</div>
            <div class="box2 blankdiv">5</div>
            <!-- <div class="box2" style="height: 180px;">6</div> -->
            <div class="blank"></div>
        </div>
        <div class="box4"></div>

    </div>
```

css:

```
   .boxes{
            overflow: auto;
        }
```

